#include <plib.h>
#include <p32xxxx.h>
#include "App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_8
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency		60000000L
#define PBFrequency			SystemFrequency / 8
#define Timer1Tick			( PBFrequency / 256 / TogglesPerSec )
#define TogglesPerSec		10

const unsigned char LCMString1[ ] = "PIC32MX795F512L"; 
const unsigned char LCMString2[ ] = "VR1:"; 
const unsigned char LCMString3[ ] = "VR2:"; 

unsigned int VR1Value = 0 , VR2Value = 0;

void __ISR( _TIMER_1_VECTOR, ipl4 ) ISR_Imier1( void )
{
	// MTimer_XСC
	mT1ClearIntFlag( );

	// To Do : ϥC32 ADC FunctionҰADCഫC
	ConvertADC10( );

	// LEDAϦVC	
	mPORTAToggleBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
}

int main( void )
{
	// disable JTAG port
    DDPCONbits.JTAGEN = 0;

	// Pɯ = tήɯ / 8C
	OSCSetPBDIV( OSC_PB_DIV_8 );

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

    // LEDI/O Port]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
    mPORTASetBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 );
	mPORTAClearBits( BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ҥTimerAëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// Timer]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );

	// To Do : ϥC32 ADC10 Function]wADCC
	OpenADC10( ADC_MODULE_ON | ADC_IDLE_CONTINUE | ADC_FORMAT_INTG16 | ADC_CLK_MANUAL | ADC_AUTO_SAMPLING_ON | ADC_SAMP_OFF ,
			   ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_ON | ADC_SAMPLES_PER_INT_2 | ADC_ALT_BUF_ON | ADC_ALT_INPUT_OFF ,
			   ADC_SAMPLE_TIME_31 | ADC_CONV_CLK_SYSTEM | ADC_CONV_CLK_32Tcy ,
			   ENABLE_AN2_ANA | ENABLE_AN4_ANA , 
			   SKIP_SCAN_AN0 | SKIP_SCAN_AN1 | SKIP_SCAN_AN3 | SKIP_SCAN_AN5 | SKIP_SCAN_AN6 | SKIP_SCAN_AN7 |
			   SKIP_SCAN_AN8 | SKIP_SCAN_AN9 | SKIP_SCAN_AN10 | SKIP_SCAN_AN11 | SKIP_SCAN_AN12 | SKIP_SCAN_AN13 |
			   SKIP_SCAN_AN14 | SKIP_SCAN_AN15 );

	// To Do : ϥC32 I/O Port FunctionNTADqD]wJC
	PORTSetPinsAnalogIn( IOPORT_B , BIT_2 | BIT_4 );

    INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{
		// ഫ ?
		if( INTGetFlag( INT_AD1 ) )
		{
			// To Do : ϥC32 ADC10 FunctionŪADCഫƭȡC
			VR1Value = ( unsigned int ) ReadADC10( 0 );
			VR2Value = ( unsigned int ) ReadADC10( 1 );

			// MADC_X
			INTClearFlag( INT_AD1 );

			// ]wCСAXADCƭȡC
			LCM_SetCursor( 0 , 1 );
			LCM_PutROMString( LCMString2 );
			LCM_PutNumber( VR1Value , 4 );
			LCM_PutASCII( ',' );
			LCM_PutROMString( LCMString3 );
			LCM_PutNumber( VR2Value >> 1 , 3 );
		}
	}

	while( 1 );
}
